*******************************************************************************
*                          680xx Grundprogramm cent                           *
*                         (C) 1990 Ralph Dombrowski                           *
*                             2009 Jens Mewes                                 *
*                               V 7.10 Rev 4                                  *
*                                01.05.2009                                   *
*                           Centronicsroutinen                                *
*******************************************************************************


* Unterprogramme Drucker ber Centronics

loinit:                         * Druckerinit
 move.b #1,centstb.w
rts

locrlf:                         * Ausgabe eines Linefeed ber die Drucker-
 moveq #$d,d0                   * schnittstelle
 bsr.s lo2
 moveq #$a,d0
bra.s lo2

lolf:                           * Zeichen auf Drucken ausgeben ohne LF
 cmp.b #$a,d0
 bne.s lo2                      * Ignorieren wenn LF
rts

prtlo:                          * Zeichenfolge auf Drucker ausgeben
 move.b (a0)+,d0
 beq carres                     * Null ist Ende
 bsr.s lo2                      * An Drucker ohne Zeichensatzumschaltung
bra.s prtlo

lo:                             * Alle Zeichen auf Drucker ausgeben
 btst.b #1,dflag0(a5)           * Zeichensatzumschaltung
 beq.s lo1                      * Wenn Bit 1=0, dann keine Umschaltung
 tst.b d0
 bmi.s lo0                      * Springen, wenn deutsches Zeichen
 btst.b #2,dflag0(a5)           * Bit 2 testen
 beq.s lo1                      * Kein Umschalten
 bsr amerdr                     * Amerikanischen Zeichensatz an
bra.s lo1                       * Zeichen ausgeben
lo0:
 btst.b #2,dflag0(a5)           * Deutsches Zeichen
 bne.s lo1                      * Aber nicht umschalten
 bsr deutdr                     * Deutschen Zeichensatz an
lo1:
 and.b #$7f,d0                  * Bit 7 lschen

lo2:                            * Einsprung Ausgabe ohne Sonderfunktion
 btst.b #1,serflag(a5)          * lo auf serielle Karte geschaltet ?
 bne so                         * Ja
lo3:
 btst.b #0,centin.w
 bne.s lo3                      * Warten bis Busy = Low-Signal
 move.b d0,centdaten.w          * Ausgabe Datenport
 nop                            * Fr schnelle CPU
 clr.b centstb.w
 nop
 nop                            * Fr schnelle CPU

 move.b #1,centstb.w            * ---...--- Strobeform
rts

lsts:
 btst.b #1,serflag(a5)          * Auf serielle Karte geschaltet ?
 bne sosts                      * Ja
 moveq #0,d0                    * Testen, ob Drucker fertig
 btst.b #0,centin.w             * Byte innerhalb Langwort gltig
 seq d0                         * $ff = Bereit / 0 = Nicht bereit
 tst.b d0                       * Auch Flags setzen
rts
